Index: trunk/src/org/expeditee/settings/UserSettings.java
===================================================================
--- trunk/src/org/expeditee/settings/UserSettings.java	(revision 1287)
+++ trunk/src/org/expeditee/settings/UserSettings.java	(revision 1328)
@@ -239,45 +239,37 @@
 		return expeditee_home;
 	}
-
+	
 	public static void appendDefaultFolders() {
-		if (PublicAndPrivateResources && AuthenticatorBrowser.isAuthenticated()) {
-			// The comments here explain how things have changed with the new regime.
-			// FrameDirs
-			// 1. PROFILE_PATH					Still points to same place.
-			// 2. SHARED_FRAMESETS_PATH			Still points to same place. (encryption stops just anyone reading it)
-			// 3. framesets-<username>			Generated on user account creation and must be refreshed on user switching.  Also gives access to tutorial stuffs.
-			// 4. FRAME_PATH					<expeditee-home>\resources-public\framesets.
-			// 5. HELP_PUBLIC_PATH				<expeditee-home>\resources-public\documentation.
-			// 6. MESSAGES_PATH					Still points to same place.  Should these be per user and encrypted?
-			// 7. PUBLIC_PATH					Still points to same place.  Kept for compatibility.
-			FolderSettings.FrameDirs.addAbsoluteDir(FrameIO.PROFILE_PATH);
+		FolderSettings.FrameDirs.addAbsoluteDir(FrameIO.PUBLIC_PATH);
+		FolderSettings.FrameDirs.addAbsoluteDir(FrameIO.TRASH_PATH);
+		FolderSettings.FrameDirs.addAbsoluteDir(FrameIO.PROFILE_PATH);
+		
+		if (PublicAndPrivateResources) {
+			FolderSettings.FrameDirs.addAbsoluteDir(FrameIO.HELP_PATH);
+			FolderSettings.FrameDirs.addAbsoluteDir(FrameIO.HELP_PRIVATE_PATH);
+			FolderSettings.FrameDirs.addAbsoluteDir(FrameIO.FRAME_PATH);
 			FolderSettings.FrameDirs.addAbsoluteDir(FrameIO.FRAME_PRIVATE_PATH);
-			FolderSettings.FrameDirs.addAbsoluteDir(FrameIO.SHARED_FRAMESETS_PATH);
-			FolderSettings.FrameDirs.addAbsoluteDir(FrameIO.FRAME_PATH);
-			FolderSettings.FrameDirs.addAbsoluteDir(FrameIO.RESOURCES_PATH);
 			FolderSettings.FrameDirs.addAbsoluteDir(FrameIO.MESSAGES_PATH);
-			FolderSettings.FrameDirs.addAbsoluteDir(FrameIO.PUBLIC_PATH);
-			FolderSettings.FrameDirs.addAbsoluteDir(FrameIO.HELP_PRIVATE_PATH);
-			FolderSettings.FrameDirs.addAbsoluteDir(FrameIO.MAIL_PATH);
+			if (AuthenticatorBrowser.isAuthenticated()) {
+				FolderSettings.FrameDirs.addAbsoluteDir(FrameIO.SHARED_FRAMESETS_PATH);
+			}
 			FolderSettings.FrameDirs.setDefault(FolderSettings.FrameDirs.get());
-						
-			// ImageDirs
-			// 1. resources-<username>\images	Generated on user account creation and must be refreshed on user switching.
-			// 2. IMAGES_PATH					<expeditee-home>\resources-public\images
+			
+			FolderSettings.ImageDirs.addAbsoluteDir(FrameIO.IMAGES_PATH);
 			FolderSettings.ImageDirs.addAbsoluteDir(FrameIO.IMAGES_PRIVATE_PATH);
-			FolderSettings.ImageDirs.addAbsoluteDir(FrameIO.IMAGES_PATH);
 			FolderSettings.ImageDirs.setDefault(FolderSettings.ImageDirs.get());
 			
+			FolderSettings.AudioDirs.addAbsoluteDir(FrameIO.AUDIO_PATH);
 			FolderSettings.AudioDirs.addAbsoluteDir(FrameIO.AUDIO_PRIVATE_PATH);
-			FolderSettings.AudioDirs.addAbsoluteDir(FrameIO.AUDIO_PATH);
 			FolderSettings.AudioDirs.setDefault(FolderSettings.AudioDirs.get());
 		} else {
+			FolderSettings.FrameDirs.addAbsoluteDir(FrameIO.HELP_PATH);
 			FolderSettings.FrameDirs.addAbsoluteDir(FrameIO.FRAME_PATH);
-			FolderSettings.FrameDirs.addAbsoluteDir(FrameIO.PUBLIC_PATH);
-			FolderSettings.FrameDirs.addAbsoluteDir(FrameIO.PROFILE_PATH);
-			FolderSettings.FrameDirs.addAbsoluteDir(FrameIO.HELP_PATH);
 			FolderSettings.FrameDirs.addAbsoluteDir(FrameIO.MESSAGES_PATH);
+			if (AuthenticatorBrowser.isAuthenticated()) {
+				FolderSettings.FrameDirs.addAbsoluteDir(FrameIO.SHARED_FRAMESETS_PATH);
+			}
 			FolderSettings.FrameDirs.setDefault(FolderSettings.FrameDirs.get());
-
+			
 			FolderSettings.ImageDirs.addAbsoluteDir(FrameIO.IMAGES_PATH);
 			FolderSettings.ImageDirs.setDefault(FolderSettings.ImageDirs.get());
@@ -287,4 +279,55 @@
 		}
 	}
+
+//	public static void appendDefaultFolders() {
+//		if (PublicAndPrivateResources && AuthenticatorBrowser.isAuthenticated()) {
+//			// The comments here explain how things have changed with the new regime.
+//			// FrameDirs
+//			// 1. PROFILE_PATH					Still points to same place.
+//			// 2. SHARED_FRAMESETS_PATH			Still points to same place. (encryption stops just anyone reading it)
+//			// 3. framesets-<username>			Generated on user account creation and must be refreshed on user switching.  Also gives access to tutorial stuffs.
+//			// 4. FRAME_PATH					<expeditee-home>\resources-public\framesets.
+//			// 5. HELP_PUBLIC_PATH				<expeditee-home>\resources-public\documentation.
+//			// 6. MESSAGES_PATH					Still points to same place.  Should these be per user and encrypted?
+//			// 7. PUBLIC_PATH					Still points to same place.  Kept for compatibility.
+//			FolderSettings.FrameDirs.addAbsoluteDir(FrameIO.PROFILE_PATH);
+//			FolderSettings.FrameDirs.addAbsoluteDir(FrameIO.FRAME_PRIVATE_PATH);
+//			FolderSettings.FrameDirs.addAbsoluteDir(FrameIO.SHARED_FRAMESETS_PATH);
+//			FolderSettings.FrameDirs.addAbsoluteDir(FrameIO.FRAME_PATH);
+//			FolderSettings.FrameDirs.addAbsoluteDir(FrameIO.RESOURCES_PATH);
+//			FolderSettings.FrameDirs.addAbsoluteDir(FrameIO.MESSAGES_PATH);
+//			FolderSettings.FrameDirs.addAbsoluteDir(FrameIO.PUBLIC_PATH);
+//			FolderSettings.FrameDirs.addAbsoluteDir(FrameIO.HELP_PRIVATE_PATH);
+//			FolderSettings.FrameDirs.addAbsoluteDir(FrameIO.MAIL_PATH);
+//			FolderSettings.FrameDirs.setDefault(FolderSettings.FrameDirs.get());
+//						
+//			// ImageDirs
+//			// 1. resources-<username>\images	Generated on user account creation and must be refreshed on user switching.
+//			// 2. IMAGES_PATH					<expeditee-home>\resources-public\images
+//			FolderSettings.ImageDirs.addAbsoluteDir(FrameIO.IMAGES_PRIVATE_PATH);
+//			FolderSettings.ImageDirs.addAbsoluteDir(FrameIO.IMAGES_PATH);
+//			FolderSettings.ImageDirs.setDefault(FolderSettings.ImageDirs.get());
+//			
+//			FolderSettings.AudioDirs.addAbsoluteDir(FrameIO.AUDIO_PRIVATE_PATH);
+//			FolderSettings.AudioDirs.addAbsoluteDir(FrameIO.AUDIO_PATH);
+//			FolderSettings.AudioDirs.setDefault(FolderSettings.AudioDirs.get());
+//		} else {
+//			FolderSettings.FrameDirs.addAbsoluteDir(FrameIO.FRAME_PATH);
+//			FolderSettings.FrameDirs.addAbsoluteDir(FrameIO.PUBLIC_PATH);
+//			FolderSettings.FrameDirs.addAbsoluteDir(FrameIO.PROFILE_PATH);
+//			FolderSettings.FrameDirs.addAbsoluteDir(FrameIO.HELP_PATH);
+//			FolderSettings.FrameDirs.addAbsoluteDir(FrameIO.MESSAGES_PATH);
+//			if (FrameIO.FRAME_PRIVATE_PATH != null) {
+//				FolderSettings.FrameDirs.addAbsoluteDir(FrameIO.FRAME_PRIVATE_PATH);
+//			}
+//			FolderSettings.FrameDirs.setDefault(FolderSettings.FrameDirs.get());
+//			
+//			FolderSettings.ImageDirs.addAbsoluteDir(FrameIO.IMAGES_PATH);
+//			FolderSettings.ImageDirs.setDefault(FolderSettings.ImageDirs.get());
+//			
+//			FolderSettings.AudioDirs.addAbsoluteDir(FrameIO.AUDIO_PATH);
+//			FolderSettings.AudioDirs.setDefault(FolderSettings.AudioDirs.get());
+//		}
+//	}
 
 	/**