Index: trunk/src/org/expeditee/auth/Actions.java
===================================================================
--- trunk/src/org/expeditee/auth/Actions.java	(revision 1330)
+++ trunk/src/org/expeditee/auth/Actions.java	(revision 1331)
@@ -529,5 +529,5 @@
 		
 		// Copy private resources to personal area
-		Path personalResources = FrameIO.setupPersonalResources(username);
+		Path personalResources = UserSettings.PublicAndPrivateResources ? FrameIO.setupPersonalResources(username) : Paths.get(FrameIO.PARENT_FOLDER);
 		
 		File contactsDir = new File(personalResources.resolve("contacts").toAbsolutePath().toString());
Index: trunk/src/org/expeditee/gui/FrameUtils.java
===================================================================
--- trunk/src/org/expeditee/gui/FrameUtils.java	(revision 1330)
+++ trunk/src/org/expeditee/gui/FrameUtils.java	(revision 1331)
@@ -29,6 +29,10 @@
 import java.net.URL;
 import java.net.URLConnection;
+import java.nio.file.FileVisitResult;
+import java.nio.file.FileVisitor;
+import java.nio.file.Files;
 import java.nio.file.Path;
 import java.nio.file.Paths;
+import java.nio.file.attribute.BasicFileAttributes;
 import java.util.ArrayList;
 import java.util.Arrays;
@@ -49,4 +53,5 @@
 import org.expeditee.agents.ExistingFramesetException;
 import org.expeditee.agents.InvalidFramesetNameException;
+import org.expeditee.auth.AuthenticatorBrowser;
 import org.expeditee.auth.gui.MailBay;
 import org.expeditee.core.Colour;
@@ -1835,11 +1840,54 @@
 			Path resourcesPublic = Paths.get(FrameIO.PARENT_FOLDER).resolve("resources-public");
 			extractResources("org/expeditee/assets/resources-public", resourcesPublic, force);
+		} else if (AuthenticatorBrowser.isAuthenticationRequired()) {
+			// Deal with the instance of being in the old regime but using authentication.
+			
+			// Ensure additional framesets
+			Path framesetsDir = Paths.get(FrameIO.FRAME_PATH);
+			boolean extracted = extractResources("org/expeditee/assets/resources-public/framesets", framesetsDir, force);
+			
+			// Ensure additional images
+			Path imagesDir = Paths.get(FrameIO.IMAGES_PATH);
+			extracted |= extractResources("org/expeditee/assets/resources-public/images", imagesDir, force);
+			
+			// Ensure deaddrops area exists
+			Paths.get(FrameIO.PARENT_FOLDER).resolve("deaddrops").toFile().mkdir();
+			
+			if (extracted) {
+				// Ensure the default profile is 'update to date'.  
+				//NB: this limits the potential for those running old regime with authentication the ability to customise the default profile.
+				Path defaultProfile = Paths.get(FrameIO.PROFILE_PATH).resolve("default");
+				try {
+					Files.walkFileTree(defaultProfile, new FileVisitor<Path>() {
+						@Override
+						public FileVisitResult postVisitDirectory(Path dir, IOException exc) throws IOException {
+							dir.toFile().delete();
+							return FileVisitResult.CONTINUE;
+						}
+						@Override
+						public FileVisitResult preVisitDirectory(Path dir, BasicFileAttributes attrs) throws IOException {
+							return FileVisitResult.CONTINUE;
+						}
+						@Override
+						public FileVisitResult visitFile(Path file, BasicFileAttributes attrs) throws IOException {
+							file.toFile().delete();
+							return FileVisitResult.CONTINUE;
+						}
+						@Override
+						public FileVisitResult visitFileFailed(Path file, IOException exc) throws IOException {
+							return FileVisitResult.CONTINUE;
+						}
+					});
+				} catch (IOException e) {
+					e.printStackTrace();
+				}
+			}
 		}
 	}
 	
-	private static void extractResources(String source, Path destination, boolean force) {
+	private static boolean extractResources(String source, Path destination, boolean force) {
 		// If resources have already been extracted, and we are not forcing the extraction, there is nothing to do.
 		if (!force && destination.resolve(".res").toFile().exists()) {
-			return;
+			return false;
 		}
 		
@@ -1893,4 +1941,6 @@
 			System.err.println("Error: FrameUtils::extractResources.  Unable to create the .res file to flag that resources have been extracted.  Message: " + e.getMessage());
 		}
+		
+		return true;
 	}
 