Index: /trunk/src/org/expeditee/assets/resources-public/framesets/authentication/3.exp
===================================================================
--- /trunk/src/org/expeditee/assets/resources-public/framesets/authentication/3.exp	(revision 1334)
+++ /trunk/src/org/expeditee/assets/resources-public/framesets/authentication/3.exp	(revision 1335)
@@ -1,15 +1,16 @@
-V 59
+V 82
+p 40
 U authadmin
 D 07Jan2019[14:34]
 M authadmin
-d 21Mar2019[12:23]
+d 29Apr2019[15:02]
 B 100 100 39 100
 Z
 
-S T 106
-s 12Feb2019[12:34.37]
-d 0 0 0 100
-P 20 95
-T Expeditee: Sleek like Aphroditē–Wise like Athēnâ.
+S T 122
+s 29Apr2019[14:52.55]
+d 0 0 0 100
+P 105 65
+T Secure Expeditee:
 o authadmin
 v S
@@ -21,8 +22,36 @@
 p 40
 
-S T 107
-s 12Feb2019[12:34.37]
-d 0 0 0 100
-P 283 140
+S T 123
+s 29Apr2019[14:52.55]
+d 0 0 0 100
+P 20 104
+T 🔒
+o authadmin
+v S
+f tr74
+t -1.0
+b 0.0
+m 0.0
+h -1.0
+p 40
+
+S T 124
+s 29Apr2019[14:52.55]
+d 0 0 0 100
+P 105 115
+T Sleek like Aphroditē–Wise like Athēnâ.
+o authadmin
+v S
+f Metamorphous_r36
+t -1.0
+b 0.0
+m 0.0
+h -1.0
+p 40
+
+S T 142
+s 29Apr2019[14:53.06]
+d 0 0 0 100
+P 260 185
 T Change Your Expeditee Password
 o authadmin
@@ -33,41 +62,4 @@
 m 0.0
 h -1.0
-p 40
-
-S T 59
-s 07Jan2019[14:35.49]
-G 100 100 100 100
-K 0 0 0 100
-P 367 207
-T 
-D txtPassword
-o authadmin
-v S
-f tr29
-t -1.0
-O 42
-b 0.0
-m 0.0
-M 500
-h 1.0
-p 44
-
-S T 40
-s 07Jan2019[14:34.33]
-d 0 0 0 100
-K 0 0 0 100
-P 140 209
-T Old Password: 
-X AuthorisationState 2
-x F
-o authadmin
-n F
-v S
-f Amaranth_r29
-t -1.0
-b 0.0
-m 0.0
-M 200
-h 0.0
 p 40
 
@@ -90,11 +82,34 @@
 h 2.0
 
+S T 59
+s 07Jan2019[14:35.49]
+d 0 0 0 100
+G 100 100 100 100
+K 0 0 0 100
+P 175 289
+T 
+D txtPassword
+N 260
+o authadmin
+v S
+f tr29
+t -1.0
+O 42
+b 0.0
+m 0.0
+M 300
+h 1.0
+p 44
+_ph Password
+
 S T 74
 s 07Jan2019[14:36.41]
+d 0 0 0 100
 G 100 100 100 100
 K 0 0 0 100
-P 367 273
+P 175 349
 T 
 D txtNewPassword
+N 320
 o authadmin
 v S
@@ -104,34 +119,18 @@
 b 0.0
 m 0.0
-M 500
+M 300
 h 1.0
 p 44
-
-S T 43
-s 07Jan2019[14:34.33]
-d 0 0 0 100
-K 0 0 0 100
-P 140 275
-T New Password:
-X AuthorisationState 2
-x F
-o authadmin
-n F
-v S
-f Amaranth_r29
-t -1.0
-b 0.0
-m 0.0
-M 200
-h 0.0
-p 40
+_ph New Password
 
 S T 81
 s 07Jan2019[14:36.49]
+d 0 0 0 100
 G 100 100 100 100
 K 0 0 0 100
-P 367 339
+P 515 349
 T 
 D txtNewPasswordAgain
+N 320
 o authadmin
 v S
@@ -141,26 +140,8 @@
 b 0.0
 m 0.0
-M 500
+M 300
 h 1.0
 p 44
-
-S T 44
-s 07Jan2019[14:34.33]
-d 0 0 0 100
-K 0 0 0 100
-P 140 341
-T Password Again:
-X AuthorisationState 2
-x F
-o authadmin
-n F
-v S
-f Amaranth_r29
-t -1.0
-b 0.0
-m 0.0
-M 200
-h 0.0
-p 40
+_ph New Password Again
 
 S T 45
@@ -169,8 +150,9 @@
 G 100 100 0 100
 K 0 0 0 100
-P 353 415
-T  Change My Password 
+P 394 409
+T Change Password
 X AuthChangePassword
 x F
+N 380
 o authadmin
 n F
@@ -180,37 +162,35 @@
 b 0.0
 m 0.0
-M 300
+M 205
 h 1.0
 p 41
 
-S T 95
-s 11Feb2019[14:31.40]
+S T 214
+s 29Apr2019[14:58.35]
 d 0 0 0 100
 G 100 100 0 100
 K 0 0 0 100
-P 353 491
-T     Return To Desktop
-X AuthGoToDesktop
+P 424 461
+T   Forgot Password
 x F
-D ShowOnProgress
+N 440
 o authadmin
 n F
 v S
-f dr29
-t -1.0
-b 0.0
-m 0.0
-M 300
+f dr21
+t -1.0
+b 0.0
+m 0.0
+M 180
 h 1.0
 p 41
 
-S T 46
-s 07Jan2019[14:34.33]
+S T 247
+s 29Apr2019[15:00.55]
 d 0 0 0 100
 G 100 100 0 100
 K 0 0 0 100
-P 176 573
-T       I Am New To Expeditee
-F 2
+P 424 511
+T Return To Desktop
 x F
 o authadmin
@@ -221,42 +201,14 @@
 b 0.0
 m 0.0
-M 300
+M 180
 h 1.0
 p 41
 
-S T 47
-s 07Jan2019[14:34.33]
-d 0 0 0 100
-G 100 100 0 100
-K 0 0 0 100
-P 494 573
-T            Log In To Expeditee
-F 1
-x F
-o authadmin
-n F
-v S
-f dr21
-t -1.0
-b 0.0
-m 0.0
-M 300
-h 1.0
-p 41
-
-Z
-
-Z
-
-Z
-
-ActiveTime:00:06:03
+Z
+
+Z
+
+Z
+
+ActiveTime:00:14:58
 DarkTime:00:20:25
-23:06:283 442 185 Rd
-23:06:408 442 185 Ru
-23:06:931 435 255 Rd
-23:07:033 435 255 Ru
-23:07:579 417 314 Rd
-23:07:704 417 314 Ru
-23:08:021 414 251 kRIGHT_ARROW
-23:08:658 1068 264 kRIGHT_ARROW
Index: /trunk/src/org/expeditee/auth/Actions.java
===================================================================
--- /trunk/src/org/expeditee/auth/Actions.java	(revision 1334)
+++ /trunk/src/org/expeditee/auth/Actions.java	(revision 1335)
@@ -38,4 +38,5 @@
 import org.expeditee.auth.account.Authenticate.AuthenticationResult;
 import org.expeditee.auth.account.Create;
+import org.expeditee.auth.account.Password;
 import org.expeditee.auth.gui.MailBay;
 import org.expeditee.auth.tags.AuthenticationTag;
@@ -241,5 +242,5 @@
 				} else {
 					userData.put(AuthenticationTag.Username, UserSettings.UserName.get());
-					changePassword(userData);
+					Password.changePassword(userData);
 				}
 			} else {
@@ -426,21 +427,4 @@
 	}
 	
-	/*
-	 * Changes the recorded password for a user in the key store.
-	 */
-	private static void changePassword(final Map<AuthenticationTag, String> userdata) throws NoSuchAlgorithmException, KeyStoreException, FileNotFoundException, CertificateException, IOException, ClassNotFoundException, SQLException {
-		final String username = userdata.get(AuthenticationTag.Username);
-		final String password = userdata.get(AuthenticationTag.Password);
-		final String newpassword = userdata.get(AuthenticationTag.NewPassword);
-
-		final SecretKey key = AuthenticatorBrowser.getInstance().getSecretKey(username, password);
-		if (key == null) {
-			MessageBay.errorMessage("The username + existing password combination was incorrect.");
-		} else {
-			AuthenticatorBrowser.getInstance().putKey(username, newpassword, key);
-			MessageBay.displayMessage("Password changed successfully.");
-		}
-	}
-
 //			// establish properties
 //			final String from = "noreply@expeditee.com";
Index: /trunk/src/org/expeditee/auth/account/Password.java
===================================================================
--- /trunk/src/org/expeditee/auth/account/Password.java	(revision 1335)
+++ /trunk/src/org/expeditee/auth/account/Password.java	(revision 1335)
@@ -0,0 +1,37 @@
+package org.expeditee.auth.account;
+
+import java.io.FileNotFoundException;
+import java.io.IOException;
+import java.security.KeyStoreException;
+import java.security.NoSuchAlgorithmException;
+import java.security.cert.CertificateException;
+import java.sql.SQLException;
+import java.util.Map;
+
+import javax.crypto.SecretKey;
+
+import org.expeditee.auth.AuthenticatorBrowser;
+import org.expeditee.auth.tags.AuthenticationTag;
+import org.expeditee.gui.DisplayController;
+import org.expeditee.gui.FrameIO;
+import org.expeditee.gui.MessageBay;
+
+public class Password {
+	/*
+	 * Changes the recorded password for a user in the key store.
+	 */
+	public static void changePassword(final Map<AuthenticationTag, String> userdata) throws NoSuchAlgorithmException, KeyStoreException, FileNotFoundException, CertificateException, IOException, ClassNotFoundException, SQLException {
+		final String username = userdata.get(AuthenticationTag.Username);
+		final String password = userdata.get(AuthenticationTag.Password);
+		final String newpassword = userdata.get(AuthenticationTag.NewPassword);
+
+		final SecretKey key = AuthenticatorBrowser.getInstance().getSecretKey(username, password);
+		if (key == null) {
+			MessageBay.errorMessage("The username + existing password combination was incorrect.");
+		} else {
+			AuthenticatorBrowser.getInstance().putKey(username, newpassword, key);
+			MessageBay.displayMessage("Password changed successfully.");
+			DisplayController.setCurrentFrame(FrameIO.LoadFrame("multiuser1"), true);
+		}
+	}
+}