Index: trunk/src/org/expeditee/assets/resources-public/framesets/authentication/4.exp
===================================================================
--- trunk/src/org/expeditee/assets/resources-public/framesets/authentication/4.exp	(revision 1335)
+++ trunk/src/org/expeditee/assets/resources-public/framesets/authentication/4.exp	(revision 1336)
@@ -1,15 +1,16 @@
-V 109
+V 144
+p 40
 U authadmin
 D 07Jan2019[14:34]
-M authadmin
-d 21Mar2019[12:23]
+M nobody
+d 29Apr2019[16:11]
 B 100 100 39 100
 Z
 
-S T 186
-s 12Feb2019[12:44.00]
-d 0 0 0 100
-P 20 95
-T Expeditee: Sleek like Aphroditē–Wise like Athēnâ.
+S T 305
+s 29Apr2019[15:35.07]
+d 0 0 0 100
+P 105 65
+T Secure Expeditee:
 o authadmin
 v S
@@ -21,9 +22,37 @@
 p 40
 
-S T 187
-s 12Feb2019[12:44.00]
-d 0 0 0 100
-P 362 146
-T Sharing a Frameset
+S T 306
+s 29Apr2019[15:35.07]
+d 0 0 0 100
+P 20 104
+T 🔒
+o authadmin
+v S
+f tr74
+t -1.0
+b 0.0
+m 0.0
+h -1.0
+p 40
+
+S T 307
+s 29Apr2019[15:35.07]
+d 0 0 0 100
+P 105 115
+T Sleek like Aphroditē–Wise like Athēnâ.
+o authadmin
+v S
+f Metamorphous_r36
+t -1.0
+b 0.0
+m 0.0
+h -1.0
+p 40
+
+S T 308
+s 29Apr2019[15:35.07]
+d 0 0 0 100
+P 299 185
+T Regain Access to my Account
 o authadmin
 v S
@@ -35,27 +64,52 @@
 p 40
 
-S T 192
-s 12Feb2019[12:53.42]
-d 0 0 0 100
-P 23 235
-T I want to share the
-o authadmin
-v S
-f Amaranth_r29
-t -1.0
-b 0.0
-m 0.0
-h -1.0
-p 40
-
-S T 207
-s 12Feb2019[12:56.10]
+S P 328
+s 29Apr2019[15:36.51]
+d 70 70 0 100
+P 467 252
+e 100 100 50 100
+o nobody
+v S
+h 2.0
+
+S P 329
+s 29Apr2019[15:36.51]
+d 70 70 0 100
+P 467 252
+e 100 100 50 100
+o nobody
+v S
+h 2.0
+
+S T 330
+s 29Apr2019[15:36.51]
+d 0 0 0 100
+G 100 100 100 100
+K 0 0 0 100
+P 234 289
+T 
+D txtPassword
+N 260
+o nobody
+v S
+f tr29
+t -1.0
+b 0.0
+m 0.0
+M 300
+h 1.0
+p 44
+_ph Username
+
+S T 333
+s 29Apr2019[15:37.58]
 d 0 0 0 100
 G 100 100 0 100
 K 0 0 0 100
-P 778 235
-T         Share
-X AuthShareFrameset
+P 574 289
+T Reset Password
+X AuthResetPasswordPt1
 x F
+N 260
 o authadmin
 n F
@@ -65,114 +119,108 @@
 b 0.0
 m 0.0
-M 200
+M 205
 h 1.0
 p 41
 
-S T 206
-s 12Feb2019[12:54.57]
-d 0 0 0 100
-P 634 235
-T Frameset.
-o authadmin
-v S
-f Amaranth_r29
-t -1.0
-b 0.0
-m 0.0
-h -1.0
-p 40
-
-S T 188
-s 12Feb2019[12:52.02]
-d 0 0 0 100
-G 100 100 100 100
-K 0 0 0 100
-P 281 235
-T multiuser-sharing
+S P 381
+s 29Apr2019[15:40.59]
+d 0 0 0 100
+P 992 328
+e 100 59 59 100
+o authadmin
+v S
+h 10.0
+l 385
+c 377
+
+S P 382
+s 29Apr2019[15:40.59]
+d 0 0 0 100
+P 17 328
+e 100 59 59 100
+o authadmin
+v S
+h 10.0
+l 385
+c 377
+
+S T 416
+s 29Apr2019[15:43.03]
+d 0 0 0 100
+G 100 100 100 100
+K 0 0 0 100
+P 175 389
+T 
+D txtIntergalacticNumber
+N 360
+o authadmin
+v S
+f tr29
+t -1.0
+b 0.0
+m 0.0
+M 300
+h 1.0
+p 44
+_ph Intergalactic Number
+
+S T 417
+s 29Apr2019[15:43.11]
+d 0 0 0 100
+G 100 100 100 100
+K 0 0 0 100
+P 175 449
+T 
+D txtPassword
+N 420
+o authadmin
+v S
+f tr29
+t -1.0
+b 0.0
+m 0.0
+M 300
+h 1.0
+p 44
+_ph New Password
+
+S T 418
+s 29Apr2019[15:43.17]
+d 0 0 0 100
+G 100 100 100 100
+K 0 0 0 100
+P 515 449
+T 
+D txtNewPasswordAgain
+N 420
+o nobody
+v S
+f tr29
+t -1.0
+b 0.0
+m 0.0
+M 300
+h 1.0
+p 44
+_ph New Password Again
+
+S T 503
+s 29Apr2019[15:58.13]
+d 0 0 0 100
+G 100 100 0 100
+K 0 0 0 100
+P 394 509
+T Change Password
+X AuthResetPasswordPt2
 x F
-D txtFrameset
+N 480
 o authadmin
 n F
 v S
-f Amaranth_r29
-t -1.0
-b 0.0
-m 0.0
-M 340
-h 1.0
-p 44
-
-S T 215
-s 12Feb2019[13:04.13]
-d 0 0 0 100
-P 52 303
-T 1. Fill in the field above and click the Share button.  You will see a message in the message bay confirming this step is complete.
-o authadmin
-v S
-f Amaranth_r29
-t -1.0
-b 0.0
-m 0.0
-w 950
-h -1.0
-p 40
-
-S P 41
-s 07Jan2019[14:34.33]
-d 70 70 0 100
-P 420 370
-e 100 100 50 100
-o BryceNem
-v S
-h 2.0
-
-S T 219
-s 12Feb2019[13:13.13]
-d 0 0 0 100
-P 52 390
-T 2. Navigate to 'Expeditee\framesets-shared-by-me' and use Google Drive to share with the colleagues you wish to have access to it.
-o authadmin
-v S
-f Amaranth_r29
-t -1.0
-b 0.0
-m 0.0
-w 950
-h -1.0
-p 40
-
-S T 261
-s 12Feb2019[13:27.57]
-d 0 0 0 100
-P 52 478
-T Note: When sharing a frameset with a colleague, that colleague must have access to the appropriate secret in order to actually read it.
-o authadmin
-v S
-f Amaranth_r29
-t -1.0
-b 0.0
-m 0.0
-w 950
-h -1.0
-p 40
-
-S T 263
-s 13Feb2019[10:48.49]
-d 0 0 0 100
-G 100 100 0 100
-K 0 0 0 100
-P 353 584
-T     Return To Desktop
-X AuthGoToDesktop
-x F
-D ShowOnProgress
-o authadmin
-n F
-v S
 f dr29
 t -1.0
 b 0.0
 m 0.0
-M 300
+M 205
 h 1.0
 p 41
@@ -180,11 +228,54 @@
 Z
 
-Z
-
-Z
-
-ActiveTime:00:59:29
-DarkTime:02:07:52
-23:09:507 422 210 Rd
-23:09:633 421 210 Ru
-23:10:122 1228 193 kRIGHT_ARROW
+L 385 1
+s 381 382
+
+Z
+
+C 377 3
+s 381 382
+
+Z
+
+ActiveTime:01:09:39
+DarkTime:02:10:24
+11:40:749 626 270 Ld
+11:40:851 626 270 Rd
+11:41:001 626 270 Lu
+11:41:001 626 270 Ru
+11:43:074 1086 186 kSHIFT
+11:43:267 1086 186 kT
+11:43:659 1097 186 kO
+11:43:939 1106 186 kG
+11:44:049 1115 186 kG
+11:44:211 1124 186 kL
+11:44:280 1129 186 kE
+11:44:443 1137 186 kSHIFT
+11:44:528 1137 186 kA
+11:44:755 1150 186 kU
+11:44:857 1159 186 kT
+11:44:954 1164 186 kH
+11:45:243 1173 186 kCTRL
+11:45:435 1173 186 kA
+11:46:304 1173 186 Ld
+11:46:433 1173 186 Lu
+11:47:425 731 293 Ld
+11:47:544 731 293 Rd
+11:47:697 731 293 Lu
+11:47:698 731 293 Ru
+11:49:066 1198 297 Md
+11:49:266 1198 297 Rd
+11:49:961 1198 297 Ru
+11:49:969 1198 297 Mu
+11:50:948 529 509 Ld
+11:51:099 529 509 Rd
+11:51:233 529 509 Ru
+11:51:257 529 509 Lu
+11:52:524 959 429 Md
+11:52:761 959 429 Rd
+11:52:952 959 429 Ru
+11:52:984 959 429 Mu
+11:54:044 1115 187 Md
+11:54:098 1115 187 Rd
+11:54:241 1115 187 Ru
+11:54:249 1115 187 Mu
Index: trunk/src/org/expeditee/auth/Actions.java
===================================================================
--- trunk/src/org/expeditee/auth/Actions.java	(revision 1335)
+++ trunk/src/org/expeditee/auth/Actions.java	(revision 1336)
@@ -30,5 +30,4 @@
 import javax.crypto.IllegalBlockSizeException;
 import javax.crypto.NoSuchPaddingException;
-import javax.crypto.SecretKey;
 
 import org.expeditee.agents.ExistingFramesetException;
@@ -256,4 +255,12 @@
 			DisplayController.setCurrentFrame(FrameIO.LoadFrame("authentication1"), false);
 		}
+	}
+	
+	public static void AuthResetPasswordPt1() {
+		MessageBay.displayMessage("AuthResetPasswordPt1");
+	}
+	
+	public static void AuthResetPasswordPt2() {
+		MessageBay.displayMessage("AuthResetPasswordPt2");
 	}
 	
Index: trunk/src/org/expeditee/auth/account/Password.java
===================================================================
--- trunk/src/org/expeditee/auth/account/Password.java	(revision 1335)
+++ trunk/src/org/expeditee/auth/account/Password.java	(revision 1336)
@@ -21,8 +21,8 @@
 	 * Changes the recorded password for a user in the key store.
 	 */
-	public static void changePassword(final Map<AuthenticationTag, String> userdata) throws NoSuchAlgorithmException, KeyStoreException, FileNotFoundException, CertificateException, IOException, ClassNotFoundException, SQLException {
-		final String username = userdata.get(AuthenticationTag.Username);
-		final String password = userdata.get(AuthenticationTag.Password);
-		final String newpassword = userdata.get(AuthenticationTag.NewPassword);
+	public static void changePassword(Map<AuthenticationTag, String> userdata) throws NoSuchAlgorithmException, KeyStoreException, FileNotFoundException, CertificateException, IOException, ClassNotFoundException, SQLException {
+		String username = userdata.get(AuthenticationTag.Username);
+		String password = userdata.get(AuthenticationTag.Password);
+		String newpassword = userdata.get(AuthenticationTag.NewPassword);
 
 		final SecretKey key = AuthenticatorBrowser.getInstance().getSecretKey(username, password);
@@ -35,3 +35,9 @@
 		}
 	}
+	
+	public static void forgotPassword(Map<AuthenticationTag, String> userdata) {
+		String username = userdata.get(AuthenticationTag.Username);
+		String newpassword = userdata.get(AuthenticationTag.NewPassword);
+		//AuthenticatorBrowser.getInstance().putKey(label, password, key);
+	}
 }