Index: trunk/src/org/expeditee/assets/resources-public/framesets/authentication/13.exp
===================================================================
--- trunk/src/org/expeditee/assets/resources-public/framesets/authentication/13.exp	(revision 1264)
+++ trunk/src/org/expeditee/assets/resources-public/framesets/authentication/13.exp	(revision 1370)
@@ -1,30 +1,18 @@
-V 150
+V 114
 U authadmin
 D 07Jan2019[14:34]
 M authadmin
-d 21Mar2019[12:24]
+d 21Mar2019[11:51]
 B 100 100 39 100
 Z
 
-S T 36
-s 07Jan2019[14:34.33]
-P 16 8
-T @i: C:\Users\bln4\Desktop\NGIKM Expeditee\images\expediteeicon128.png 1.48
+S T 186
+s 12Feb2019[12:44.00]
+d 0 0 0 100
+P 20 95
+T Expeditee: Sleek like Aphroditē–Wise like Athēnâ.
 o authadmin
 v S
-f tr18
-t -1.0
-b 0.0
-m 0.0
-h 0.0
-
-S T 37
-s 07Jan2019[14:34.33]
-d 0 0 0 100
-P 273 108
-T Expeditee: Secure My Access
-o authadmin
-v S
-f Metamorphous_r43
+f Metamorphous_r36
 t -1.0
 b 0.0
@@ -33,12 +21,12 @@
 p 40
 
-S T 38
-s 07Jan2019[14:34.33]
+S T 187
+s 12Feb2019[12:44.00]
 d 0 0 0 100
-P 267 171
-T Sleek like Aphroditē – Wise like Athēnâ.
+P 261 147
+T Handing out your Credentials
 o authadmin
 v S
-f Metamorphous_r32
+f Amaranth_r36
 t -1.0
 b 0.0
@@ -47,130 +35,9 @@
 p 40
 
-S T 347
-s 15Jan2019[11:28.00]
+S T 298
+s 13Feb2019[11:26.47]
 d 0 0 0 100
-K 0 0 0 100
-P 266 293
-T Colleague One: 
-x F
-o authadmin
-n F
-v S
-f Amaranth_r29
-t -1.0
-b 0.0
-m 0.0
-M 200
-h 0.0
-p 40
-
-S T 348
-s 15Jan2019[11:28.00]
-d 0 0 0 100
-G 100 100 100 100
-K 0 0 0 100
-P 493 293
-T BryceTwo
-x F
-D txtColleagueOne
-o authadmin
-n F
-v S
-f Amaranth_r29
-t -1.0
-b 0.0
-m 0.0
-M 500
-h 1.0
-p 44
-
-S P 349
-s 15Jan2019[11:28.00]
-d 70 70 0 100
-P 534 335
-e 100 100 50 100
-o authadmin
-v S
-h 2.0
-
-S T 350
-s 15Jan2019[11:28.00]
-d 70 70 0 100
-P 534 335
-T q
-e 100 100 50 100
-o authadmin
-v S
-f tr6
-t -1.0
-b 0.0
-m 0.0
-h 2.0
-
-S T 351
-s 15Jan2019[11:28.00]
-d 0 0 0 100
-G 100 100 100 100
-K 0 0 0 100
-P 493 358
-T BryceThree
-x F
-D txtColleagueTwo
-o authadmin
-n F
-v S
-f Amaranth_r29
-t -1.0
-b 0.0
-m 0.0
-M 500
-h 1.0
-p 44
-
-S T 352
-s 15Jan2019[11:28.00]
-d 0 0 0 100
-K 0 0 0 100
-P 266 358
-T Colleague Two:
-x F
-o authadmin
-n F
-v S
-f Amaranth_r29
-t -1.0
-b 0.0
-m 0.0
-M 200
-h 0.0
-p 40
-
-S T 357
-s 15Jan2019[12:07.33]
-d 0 0 0 100
-G 100 100 0 100
-K 0 0 0 100
-P 433 426
-T Submit Colleague Usernames
-X AuthSubmitPWColleagues
-x F
-o authadmin
-n F
-v S
-f dr29
-t -1.0
-b 0.0
-m 0.0
-M 300
-h 1.0
-p 41
-
-S T 363
-s 21Jan2019[12:08.20]
-d 0 0 0 100
-P 414 487
-T  Colleague usernames submitted.
-T Now we must wait for their reply.
-D ShowOnProgress
+P 23 235
+T If you want someone to be able to send you internal Expeditee messages and provide you with access to secrets for the purposes of reading encrypted framesets then you need to provide them with your contact details.  This can be done by using Google Drive sharing to share your '<username>-credentials' folder with the colleague 
 o authadmin
 v S
@@ -179,13 +46,56 @@
 b 0.0
 m 0.0
+w 950
 h -1.0
 p 40
 
-S T 366
-s 21Jan2019[12:37.12]
+S P 284
+s 13Feb2019[11:18.23]
+d 70 70 0 100
+P 420 370
+e 100 100 50 100
+o Bryce
+v S
+h 2.0
+
+S P 41
+s 07Jan2019[14:34.33]
+d 70 70 0 100
+P 410 378
+e 100 100 50 100
+o BryceNem
+v S
+h 2.0
+
+S P 300
+s 13Feb2019[11:26.47]
+d 70 70 0 100
+P 410 378
+e 100 100 50 100
+o Bryce
+v S
+h 2.0
+
+S T 351
+s 13Feb2019[11:36.14]
+d 0 0 0 100
+P 22 453
+T As long as your email address and public key remain listed on 4.exp, you may customise the frame in any way you wish.  Furthermore, any adjustments you make to 4.exp–such as changing your email address–will be reflected on your colleagues copy.
+o authadmin
+v S
+f Amaranth_r29
+t -1.0
+b 0.0
+m 0.0
+w 950
+h -1.0
+p 40
+
+S T 262
+s 13Feb2019[10:48.44]
 d 0 0 0 100
 G 100 100 0 100
 K 0 0 0 100
-P 460 579
+P 351 600
 T     Return To Desktop
 X AuthGoToDesktop
@@ -209,135 +119,19 @@
 Z
 
-ActiveTime:01:03:45
-DarkTime:00:49:36
-23:22:083 1141 310 Md
-23:22:250 1141 310 Rd
-23:23:369 1182 368 Ru
-23:23:633 1183 368 Mu
-23:24:561 1170 366 Md
-23:24:665 1170 366 Mu
-23:25:308 556 268 Ld
-23:25:458 556 268 Rd
-23:25:561 556 268 Lu
-23:25:569 556 268 Ru
-23:26:987 1105 207 Md
-23:27:169 1105 207 Rd
-23:32:745 1105 207 Ru
-23:32:809 1105 207 Mu
-23:34:362 1135 218 kSHIFT
-23:34:530 1135 218 kO
-23:34:777 1148 218 kW
-23:34:888 1161 218 kN
-23:35:106 1170 218 kE
-23:35:185 1178 218 kR
-23:35:571 1184 218 kSHIFT
-23:36:267 1193 218 kA
-23:36:401 1201 218 kU
-23:36:498 1210 218 kT
-23:36:617 1215 218 kH
-23:36:747 1224 218 kA
-23:36:865 1232 218 kD
-23:37:010 1241 218 kM
-23:37:073 1255 218 kI
-23:37:160 1260 218 kN
-23:38:723 1160 212 Md
-23:38:825 1160 212 Mu
-23:39:376 534 96 Rd
-23:39:496 534 96 Ru
-23:40:812 523 147 Rd
-23:41:001 523 147 Ru
-23:41:842 555 286 Rd
-23:41:977 555 286 Ru
-23:43:089 548 352 Rd
-23:43:217 548 352 Ru
-23:43:683 329 283 Rd
-23:43:785 329 283 Ru
-23:44:236 345 330 Rd
-23:44:377 345 330 Ru
-23:44:995 528 399 Rd
-23:45:121 528 399 Ru
-23:45:613 592 476 Rd
-23:45:729 592 476 Ru
-23:46:331 625 554 Rd
-23:46:481 625 554 Ru
-23:46:875 1014 538 Md
-23:46:954 1014 538 Rd
-23:47:096 1014 538 Ru
-23:47:097 1014 538 Mu
-23:47:681 567 280 Ld
-23:47:786 567 280 Rd
-23:47:905 567 280 Lu
-23:47:906 567 280 Ru
-23:49:252 1090 177 Md
-23:49:521 1090 177 Rd
-23:50:009 1090 177 Ru
-23:50:033 1090 177 Mu
-23:50:642 1179 361 Md
-23:50:753 1179 361 Mu
-23:51:403 556 276 Rd
-23:51:545 556 276 Ru
-23:51:995 550 337 Rd
-23:52:137 550 337 Ru
-23:52:545 1132 266 Md
-23:52:641 1132 266 Mu
-23:53:394 592 295 Ld
-23:53:515 592 295 Rd
-23:53:652 592 295 Ru
-23:53:657 592 295 Lu
-23:56:427 1180 128 Md
-23:56:473 1180 128 Rd
-23:56:689 1180 128 Ru
-23:56:713 1180 128 Mu
-24:09:258 1211 268 kBACKSPACE
-24:10:546 1177 271 Md
-24:10:633 1177 271 Mu
-24:11:297 639 115 Rd
-24:11:417 639 115 Ru
-24:11:923 622 151 Rd
-24:12:057 622 151 Ru
-24:12:531 336 281 Rd
-24:12:633 336 281 Ru
-24:12:996 336 344 Rd
-24:13:097 336 344 Ru
-24:13:643 455 484 Rd
-24:13:793 455 484 Ru
-24:14:778 1146 468 Md
-24:14:945 1146 468 Mu
-24:17:027 1181 462 kBACKSPACE
-24:18:306 1157 474 Md
-24:18:474 1161 474 Mu
-24:18:866 1164 507 Md
-24:18:922 1164 507 Rd
-24:19:057 1164 507 Ru
-24:19:097 1164 507 Mu
-24:19:578 1130 464 Md
-24:19:665 1130 464 Mu
-24:20:274 548 410 Rd
-24:20:425 548 410 Ru
-24:20:955 607 563 Rd
-24:21:081 607 563 Ru
-24:21:812 1227 441 Md
-24:21:914 1227 441 Rd
-24:22:081 1227 441 Ru
-24:22:082 1227 441 Mu
-24:22:884 626 408 Ld
-24:23:019 626 408 Rd
-24:23:105 626 408 Ru
-24:23:137 626 408 Lu
-24:23:820 1124 405 Md
-24:23:986 1124 405 Rd
-24:24:129 1124 405 Ru
-24:24:161 1124 405 Mu
-24:25:899 1141 173 kF10
-24:29:210 1141 173 kF10
-24:32:459 1176 4 kF11
-24:34:290 696 145 Ld
-24:34:427 696 145 Rd
-24:34:545 696 145 Ru
-24:34:556 697 146 Lu
-24:36:058 1268 101 Md
-24:36:347 1268 101 Rd
-24:38:073 1268 101 Ru
-24:38:074 1268 101 Mu
-24:38:402 1474 306 Ld
-24:38:473 1474 306 Lu
+ActiveTime:01:14:20
+DarkTime:02:36:19
+10:37:140 494 595 Rd
+10:37:283 494 595 Ru
+10:37:740 1134 548 Md
+10:37:876 1135 548 Mu
+10:39:389 549 599 Ld
+10:39:548 549 599 Rd
+10:39:691 549 599 Ru
+10:39:723 549 599 Lu
+10:41:267 758 612 Md
+10:41:403 758 612 Rd
+10:41:515 758 612 Ru
+10:41:555 759 612 Mu
+10:42:332 1150 539 Md
+10:42:419 1150 539 Mu
+10:42:691 1037 652 kRIGHT_ARROW