Index: trunk/src/org/expeditee/assets/resources-public/framesets/authentication/1.exp
===================================================================
--- trunk/src/org/expeditee/assets/resources-public/framesets/authentication/1.exp	(revision 1377)
+++ trunk/src/org/expeditee/assets/resources-public/framesets/authentication/1.exp	(revision 1378)
@@ -13,5 +13,5 @@
 P 105 65
 T Secure Expeditee:
-o nobody
+o authadmin
 v S
 f Metamorphous_r36
@@ -26,5 +26,5 @@
 P 20 104
 T 🔒
-o nobody
+o authadmin
 v S
 f tr74
@@ -39,5 +39,5 @@
 P 105 115
 T Sleek like Aphroditē–Wise like Athēnâ.
-o nobody
+o authadmin
 v S
 f Metamorphous_r36
@@ -52,5 +52,5 @@
 P 364 185
 T Login to Expeditee
-o nobody
+o authadmin
 v S
 f Amaranth_r36
@@ -110,5 +110,5 @@
 X AuthLogin
 x F
-o nobody
+o authadmin
 n F
 v S
@@ -126,5 +126,5 @@
 P 602 435
 e 100 100 39 100
-o nobody
+o authadmin
 v S
 h 2.0
@@ -137,5 +137,5 @@
 P 393 435
 e 100 100 39 100
-o nobody
+o authadmin
 v S
 h 2.0
@@ -149,5 +149,5 @@
 T Create Account
 F 2
-o nobody
+o authadmin
 n F
 v S
@@ -164,5 +164,5 @@
 T 
 F 2
-o nobody
+o authadmin
 n F
 v S
@@ -179,5 +179,5 @@
 T Forgot Password
 F 4
-o nobody
+o authadmin
 n F
 v S
@@ -194,5 +194,5 @@
 T 
 F 4
-o nobody
+o authadmin
 n F
 v S
@@ -208,5 +208,5 @@
 P 393 526
 e 100 100 39 100
-o nobody
+o authadmin
 v S
 h 2.0
@@ -219,5 +219,5 @@
 P 602 526
 e 100 100 39 100
-o nobody
+o authadmin
 v S
 h 2.0
Index: trunk/src/org/expeditee/assets/resources-public/framesets/authentication/3.exp
===================================================================
--- trunk/src/org/expeditee/assets/resources-public/framesets/authentication/3.exp	(revision 1377)
+++ trunk/src/org/expeditee/assets/resources-public/framesets/authentication/3.exp	(revision 1378)
@@ -123,5 +123,4 @@
 p 44
 _ph New Password
-_maxW 300
 
 S T 81
@@ -145,5 +144,4 @@
 p 44
 _ph New Password Again
-_maxW 300
 
 S T 45
@@ -173,5 +171,5 @@
 P 414 436
 e 100 100 39 100
-o nobody
+o authadmin
 v S
 h 2.0
@@ -184,5 +182,5 @@
 P 586 436
 e 100 100 39 100
-o nobody
+o authadmin
 v S
 h 2.0
@@ -197,5 +195,5 @@
 X AuthGotoAccountManagement
 x F
-o nobody
+o authadmin
 v S
 f FontAwesome_r32
@@ -212,5 +210,5 @@
 X Back
 x F
-o nobody
+o authadmin
 v S
 f FontAwesome_r32
@@ -227,5 +225,5 @@
 X AuthGoToDesktop
 x F
-o nobody
+o authadmin
 v S
 f FontAwesome_r40
@@ -241,5 +239,5 @@
 P 414 501
 e 100 100 39 100
-o nobody
+o authadmin
 v S
 h 2.0
@@ -252,5 +250,5 @@
 P 586 501
 e 100 100 39 100
-o nobody
+o authadmin
 v S
 h 2.0
Index: trunk/src/org/expeditee/assets/resources-public/framesets/authentication/5.exp
===================================================================
--- trunk/src/org/expeditee/assets/resources-public/framesets/authentication/5.exp	(revision 1377)
+++ trunk/src/org/expeditee/assets/resources-public/framesets/authentication/5.exp	(revision 1378)
@@ -77,4 +77,5 @@
 M 300
 h 1.0
+p 44
 _ph Trusted User One
 
@@ -119,4 +120,5 @@
 M 300
 h 1.0
+p 44
 _ph Trusted User Two
 
Index: trunk/src/org/expeditee/assets/resources-public/framesets/authentication/6.exp
===================================================================
--- trunk/src/org/expeditee/assets/resources-public/framesets/authentication/6.exp	(revision 1377)
+++ trunk/src/org/expeditee/assets/resources-public/framesets/authentication/6.exp	(revision 1378)
@@ -13,5 +13,5 @@
 P 1283 -354
 e 59 59 100 100
-o nobody
+o authadmin
 v S
 h 2.0
@@ -24,5 +24,5 @@
 P 967 -354
 e 59 59 100 100
-o nobody
+o authadmin
 v S
 h 2.0
@@ -34,5 +34,5 @@
 P 983 -311
 T 
-o nobody
+o authadmin
 v S
 f FontAwesome_r32
@@ -46,5 +46,5 @@
 P 1052 -307
 T 
-o nobody
+o authadmin
 v S
 f FontAwesome_r40
@@ -58,5 +58,5 @@
 P 1188 -248
 T 
-o nobody
+o authadmin
 v S
 f FontAwesome_r32
@@ -70,5 +70,5 @@
 P 1080 -247
 T 
-o nobody
+o authadmin
 v S
 f FontAwesome_r32
@@ -83,5 +83,5 @@
 P 967 -217
 e 59 59 100 100
-o nobody
+o authadmin
 v S
 h 2.0
@@ -94,5 +94,5 @@
 P 1283 -217
 e 59 59 100 100
-o nobody
+o authadmin
 v S
 h 2.0